/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.55 Revision 1.106
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.55 2009/12/22 16:04:13 abcd Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.106 2011/12/21 22:47:35 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 12inherit base eutils multilib toolchain-funcs flag-o-matic versionator
16 13
14MY_PV=${PV/_/-}
15MY_P=qt-everywhere-opensource-src-${MY_PV}
16
17HOMEPAGE="http://qt.nokia.com/ http://qt-project.org/"
18SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
19LICENSE="|| ( LGPL-2.1 GPL-3 )"
20
17IUSE="debug pch" 21IUSE="aqua debug pch"
22
23[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] &&
24[[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] &&
25 IUSE+=" +exceptions"
26
27if version_is_at_least 4.7.99999999; then
28 IUSE+=" c++0x qpa"
29fi
30
31DEPEND="dev-util/pkgconfig"
18RDEPEND=" 32RDEPEND="
19 !<x11-libs/qt-assistant-${PV} 33 !<x11-libs/qt-assistant-${PV}
20 !>x11-libs/qt-assistant-${PV}-r9999 34 !>x11-libs/qt-assistant-${PV}-r9999
21 !<x11-libs/qt-core-${PV} 35 !<x11-libs/qt-core-${PV}
22 !>x11-libs/qt-core-${PV}-r9999 36 !>x11-libs/qt-core-${PV}-r9999
23 !<x11-libs/qt-dbus-${PV} 37 !<x11-libs/qt-dbus-${PV}
24 !>x11-libs/qt-dbus-${PV}-r9999 38 !>x11-libs/qt-dbus-${PV}-r9999
39 !<x11-libs/qt-declarative-${PV}
40 !>x11-libs/qt-declarative-${PV}-r9999
25 !<x11-libs/qt-demo-${PV} 41 !<x11-libs/qt-demo-${PV}
26 !>x11-libs/qt-demo-${PV}-r9999 42 !>x11-libs/qt-demo-${PV}-r9999
27 !<x11-libs/qt-gui-${PV} 43 !<x11-libs/qt-gui-${PV}
28 !>x11-libs/qt-gui-${PV}-r9999 44 !>x11-libs/qt-gui-${PV}-r9999
45 !<x11-libs/qt-multimedia-${PV}
46 !>x11-libs/qt-multimedia-${PV}-r9999
29 !<x11-libs/qt-opengl-${PV} 47 !<x11-libs/qt-opengl-${PV}
30 !>x11-libs/qt-opengl-${PV}-r9999 48 !>x11-libs/qt-opengl-${PV}-r9999
31 !<x11-libs/qt-phonon-${PV} 49 !<x11-libs/qt-phonon-${PV}
32 !>x11-libs/qt-phonon-${PV}-r9999 50 !>x11-libs/qt-phonon-${PV}-r9999
33 !<x11-libs/qt-qt3support-${PV} 51 !<x11-libs/qt-qt3support-${PV}
44 !>x11-libs/qt-webkit-${PV}-r9999 62 !>x11-libs/qt-webkit-${PV}-r9999
45 !<x11-libs/qt-xmlpatterns-${PV} 63 !<x11-libs/qt-xmlpatterns-${PV}
46 !>x11-libs/qt-xmlpatterns-${PV}-r9999 64 !>x11-libs/qt-xmlpatterns-${PV}-r9999
47" 65"
48 66
49MY_PV=${PV/_/-}
50
51if version_is_at_least 4.5.99999999 ${PV} ; then
52 MY_P=qt-everywhere-opensource-src-${MY_PV}
53else
54 MY_P=qt-x11-opensource-src-${MY_PV}
55fi
56
57S=${WORKDIR}/${MY_P} 67S=${WORKDIR}/${MY_P}
58 68
59HOMEPAGE="http://qt.nokia.com/"
60SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
61
62LICENSE="|| ( LGPL-2.1 GPL-3 )"
63
64# @FUNCTION: qt4-build_pkg_setup 69# @FUNCTION: qt4-build_pkg_setup
65# @DESCRIPTION: 70# @DESCRIPTION:
66# Sets up PATH and LD_LIBRARY_PATH 71# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH
67qt4-build_pkg_setup() { 72qt4-build_pkg_setup() {
73 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
74
75 # Protect users by not allowing downgrades between releases
76 # Downgrading revisions within the same release should be allowed
77 if has_version '>'${CATEGORY}/${P}-r9999; then
78 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
79 eerror "Sanity check to keep you from breaking your system:"
80 eerror " Downgrading Qt is completely unsupported and will break your system!"
81 die "aborting to save your system"
82 else
83 ewarn "Downgrading Qt is completely unsupported and will break your system!"
84 fi
85 fi
86
87 if [[ ${PN} == "qt-webkit" ]]; then
88 eshopts_push -s extglob
89 if is-flagq '-g?(gdb)?([1-9])'; then
90 echo
91 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
92 ewarn "You may experience really long compilation times and/or increased memory usage."
93 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
94 ewarn "For more info check out bug #307861"
95 echo
96 fi
97 eshopts_pop
98 fi
99
68 PATH="${S}/bin${PATH:+:}${PATH}" 100 PATH="${S}/bin${PATH:+:}${PATH}"
101 if [[ ${CHOST} != *-darwin* ]]; then
69 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 102 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
103 else
104 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
105 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
106 # platform detection. Note: needs to come before any directories to
107 # avoid extract failure.
108 [[ ${CHOST} == *-apple-darwin* ]] && \
109 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
110 ${QT4_EXTRACT_DIRECTORIES}"
111 fi
70 112
71 # Make sure ebuilds use the required EAPI 113 # Make sure ebuilds use the required EAPI
72 if [[ ${EAPI} != 2 ]]; then 114 if [[ ${EAPI} != [23] ]]; then
73 eerror "The qt4-build eclass requires EAPI=2, but this ebuild does not" 115 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
74 eerror "have EAPI=2 set. The ebuild author or editor failed. This ebuild needs" 116 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
75 eerror "to be fixed. Using qt4-build-edge eclass without EAPI=2 will fail." 117 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
76 die "qt4-build-edge eclass requires EAPI=2" 118 die "qt4-build eclass requires EAPI=2 or EAPI=3"
77 fi 119 fi
78 120
79 if ! version_is_at_least 4.1 $(gcc-version); then 121 if ! version_is_at_least 4.1 $(gcc-version); then
80 ewarn "Using a GCC version lower than 4.1 is not supported!" 122 ewarn "Using a GCC version lower than 4.1 is not supported!"
81 echo
82 ebeep 3
83 fi 123 fi
84
85 if [[ ${P} == qt-core-4.6.0_rc1 ]]; then
86 ewarn
87 ewarn "Binary compatibility broke between 4.6.0_beta1 and 4.6.0_rc1."
88 ewarn "If you are upgrading from 4.6.0_beta1, you'll have to"
89 ewarn "re-emerge everything that depends on Qt."
90 ewarn "Use the following command:"
91 ewarn
92 ewarn " emerge -av1 \$(for i in \$(qlist -IC x11-libs/qt-);"
93 ewarn " do equery -q d \$i | grep -v 'x11-libs/qt-' |"
94 ewarn " sed \"s/^/=/\"; done)"
95 ewarn
96 ewarn "YOU'VE BEEN WARNED"
97 ewarn
98 ebeep 3
99 fi
100
101} 124}
102 125
103# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 126# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
104# @DESCRIPTION: 127# @DESCRIPTION:
105# Arguments for build_target_directories. Takes the directories, in which the 128# Arguments for build_target_directories. Takes the directories, in which the
113# @FUNCTION: qt4-build_src_unpack 136# @FUNCTION: qt4-build_src_unpack
114# @DESCRIPTION: 137# @DESCRIPTION:
115# Unpacks the sources 138# Unpacks the sources
116qt4-build_src_unpack() { 139qt4-build_src_unpack() {
117 setqtenv 140 setqtenv
141 local unpack_p="${MY_P}"
142 case "${PV}" in
143 4.8.0_*)
144 unpack_p="qt-everywhere-opensource-src-${PV/_*}"
145 ;;
146 esac
118 local target targets= 147 local target targets=
119 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \ 148 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
120 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 149 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \
121 ${QT4_EXTRACT_DIRECTORIES}; do 150 ${QT4_EXTRACT_DIRECTORIES}; do
122 targets+=" ${MY_P}/${target}" 151 targets+=" ${unpack_p}/${target}"
123 done 152 done
124 153
125 echo tar xzpf "${DISTDIR}"/${MY_P}.tar.gz ${targets} 154 echo tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets}
126 tar xzpf "${DISTDIR}"/${MY_P}.tar.gz ${targets} 155 tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die
156 case "${PV}" in
157 4.8.0_*)
158 mv ${WORKDIR}/qt-everywhere-opensource-src-${PV/_*} \
159 ${WORKDIR}/qt-everywhere-opensource-src-${MY_PV}
160 ;;
161 esac
127} 162}
128 163
129# @ECLASS-VARIABLE: PATCHES 164# @ECLASS-VARIABLE: PATCHES
130# @DESCRIPTION: 165# @DESCRIPTION:
131# In case you have patches to apply, specify them in PATCHES variable. Make sure 166# In case you have patches to apply, specify them in PATCHES variable. Make sure
141# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 176# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf.
142qt4-build_src_prepare() { 177qt4-build_src_prepare() {
143 setqtenv 178 setqtenv
144 cd "${S}" 179 cd "${S}"
145 180
181 # fix qt 4.7 regression that skips -fvisibility=hidden
182 if version_is_at_least "4.7.0_beta1"; then
183 sed -e "s/^gcc|g++)/*gcc|*g++)/" \
184 -i config.tests/unix/fvisibility.test ||
185 die "visibility fixing sed failed"
186 fi
187
188 if version_is_at_least "4.7"; then
189 # fix libX11 dependency on non X packages
190 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
191 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
192
193 qt_assistant_cleanup
194 fi
195
196 if use aqua; then
197 # provide a proper macx-g++-64
198 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
199
200 sed -e '/^CONFIG/s:app_bundle::' \
201 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
202 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed"
203 fi
204
146 if [[ ${PN} != qt-core ]]; then 205 if [[ ${PN} != qt-core ]]; then
147 skip_qmake_build_patch 206 skip_qmake_build
148 skip_project_generation_patch 207 skip_project_generation
149 symlink_binaries_to_buildtree 208 symlink_binaries_to_buildtree
150 fi 209 fi
151 210
152 # Bug 282984 && Bug 295530 211 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then
153 sed -e "s:\(^SYSTEM_VARIABLES\):CC=$(tc-getCC)\nCXX=$(tc-getCXX)\n\1:" \ 212 # qmake bus errors with -O2 but -O3 works
154 -i configure || die "sed qmake compilers failed" 213 replace-flags -O2 -O3
155 sed -e "s:\(\$MAKE\):\1 CC=$(tc-getCC) CXX=$(tc-getCXX) LD=$(tc-getCXX):" \ 214 fi
156 -i config.tests/unix/compile.test || die "sed test compilers failed"
157 215
158 # Bug 178652 216 # Bug 178652
159 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 217 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
160 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 218 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
161 append-flags -fno-gcse 219 append-flags -fno-gcse
220 fi
221
222 if use_if_iuse c++0x; then
223 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
224 ewarn "this is an official standard, some of the reverse dependencies"
225 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
226 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
227 ewarn "disabled."
228 append-flags -std=c++0x
162 fi 229 fi
163 230
164 # Unsupported old gcc versions - hardened needs this :( 231 # Unsupported old gcc versions - hardened needs this :(
165 if [[ $(gcc-major-version) -lt 4 ]] ; then 232 if [[ $(gcc-major-version) -lt 4 ]] ; then
166 ewarn "Appending -fno-stack-protector to CXXFLAGS" 233 ewarn "Appending -fno-stack-protector to CXXFLAGS"
174 if use ppc64; then 241 if use ppc64; then
175 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 242 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
176 append-flags -mminimal-toc 243 append-flags -mminimal-toc
177 fi 244 fi
178 245
246 # Bug 282984 && Bug 295530
247 sed -e "s:\(^SYSTEM_VARIABLES\):CC=\"$(tc-getCC)\"\nCXX=\"$(tc-getCXX)\"\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \
248 -i configure || die "sed qmake compilers failed"
249
250 # Bug 321335
251 if version_is_at_least 4.6; then
252 find ./config.tests/unix -name "*.test" -type f -exec grep -lZ \$MAKE '{}' \; | \
253 xargs -0 \
254 sed -e "s:\(\$MAKE\):\1 CC=\"$(tc-getCC)\" CXX=\"$(tc-getCXX)\" LD=\"$(tc-getCXX)\" LINK=\"$(tc-getCXX)\":g" \
255 -i || die "sed test compilers failed"
256 fi
257
179 # Bug 172219 258 # Bug 172219
180 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
181 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
182 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \
183 -e "s:X11R6/::" \ 259 sed -e "s:X11R6/::" \
184 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed" 260 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
185 261
262 if [[ ${CHOST} == *-darwin* ]]; then
263 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
264 # crippled (by design) :/
186 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 265 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
187 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 266 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
188 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 267 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
268 -e "s:-arch\s\w*::g" \
189 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 269 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed"
270
271 # Fix configure's -arch settings that appear in qmake/Makefile and also
272 # fix arch handling (automagically duplicates our -arch arg and breaks
273 # pch). Additionally disable Xarch support.
274 sed \
275 -e "s:-arch i386::" \
276 -e "s:-arch ppc::" \
277 -e "s:-arch x86_64::" \
278 -e "s:-arch ppc64::" \
279 -e "s:-arch \$i::" \
280 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
281 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
282 -e "s:-Xarch_x86_64::g" \
283 -e "s:-Xarch_ppc64::g" \
284 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed"
285
286 # On Snow Leopard don't fall back to 10.5 deployment target.
287 if [[ ${CHOST} == *-apple-darwin10 ]] ; then
288 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
289 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
290 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed"
291 fi
292 fi
293
294 # this one is needed for all systems with a separate -liconv, apart from
295 # Darwin, for which the sources already cater for -liconv
296 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then
297 sed \
298 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
299 -i config.tests/unix/iconv/iconv.pro \
300 || die "sed on iconv.pro failed"
301 fi
302
303 # we need some patches for Solaris
304 sed -i \
305 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
306 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
307 # use GCC over SunStudio
308 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
309 # don't flirt with non-Prefix stuff, we're quite possessive
310 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
311 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
312 # strip predefined CFLAGS from qmake ( bug #312689 )
313 sed -i '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf
190 314
191 base_src_prepare 315 base_src_prepare
192} 316}
193 317
194# @FUNCTION: qt4-build_src_configure 318# @FUNCTION: qt4-build_src_configure
196# Default configure phase 320# Default configure phase
197qt4-build_src_configure() { 321qt4-build_src_configure() {
198 setqtenv 322 setqtenv
199 myconf="$(standard_configure_options) ${myconf}" 323 myconf="$(standard_configure_options) ${myconf}"
200 324
325 # this one is needed for all systems with a separate -liconv, apart from
326 # Darwin, for which the sources already cater for -liconv
327 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \
328 myconf+=" -liconv"
329
330 if use_if_iuse glib; then
331 # use -I, -L and -l from configure
332 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
333 # avoid the -pthread argument
334 myconf+=" ${glibflags//-pthread}"
335 unset glibflags
336 fi
337
338 if use_if_iuse qpa; then
339 ewarn
340 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
341 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
342 ewarn "disable it before reporting any bugs related to this useflag."
343 ewarn
344 myconf+=" -qpa"
345 fi
346
347 if use aqua ; then
348 # On (snow) leopard use the new (frameworked) cocoa code.
349 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then
350 myconf+=" -cocoa -framework"
351
352 # We are crazy and build cocoa + qt3support :-)
353 if use qt3support; then
354 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
355 -i configure
356 fi
357
358 # We need the source's headers, not the installed ones.
359 myconf+=" -I${S}/include"
360
361 # Add hint for the framework location.
362 myconf+=" -F${QTLIBDIR}"
363 fi
364 else
365 # freetype2 include dir is non-standard, thus include it on configure
366 # use -I from configure
367 myconf+=" $(pkg-config --cflags freetype2)"
368 fi
369
201 echo ./configure ${myconf} 370 echo ./configure ${myconf}
202 ./configure ${myconf} || die "./configure failed" 371 ./configure ${myconf} || die "./configure failed"
203 myconf="" 372 myconf=""
373
374 prepare_directories ${QT4_TARGET_DIRECTORIES}
204} 375}
205 376
206# @FUNCTION: qt4-build_src_compile 377# @FUNCTION: qt4-build_src_compile
378# @DESCRIPTION:
207# @DESCRIPTION: Actual compile phase 379# Actual compile phase
208qt4-build_src_compile() { 380qt4-build_src_compile() {
209 setqtenv 381 setqtenv
210 382
211 build_directories ${QT4_TARGET_DIRECTORIES} 383 build_directories ${QT4_TARGET_DIRECTORIES}
212} 384}
213 385
386# @FUNCTION: qt4-build_src_test
387# @DESCRIPTION:
388# Runs tests only in target directories.
389qt4-build_src_test() {
390 for dir in ${QT4_TARGET_DIRECTORIES}; do
391 emake -j1 check -C ${dir}
392 done
393}
394
395# @FUNCTION: fix_includes
396# @DESCRIPTION:
397# For MacOSX we need to add some symlinks when frameworks are
398# being used, to avoid complications with some more or less stupid packages.
399fix_includes() {
400 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then
401 # Some packages tend to include <Qt/...>
402 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
403
404 # Fake normal headers when frameworks are installed... eases life later on
405 local dest f
406 for frw in "${D}${QTLIBDIR}"/*.framework; do
407 [[ -e "${frw}"/Headers ]] || continue
408 f=$(basename ${frw})
409 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
410 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}"
411
412 # Link normal headers as well.
413 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
414 h=$(basename ${hdr})
415 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
416 done
417 done
418 fi
419}
420
214# @FUNCTION: qt4-build_src_install 421# @FUNCTION: qt4-build_src_install
215# @DESCRIPTION: 422# @DESCRIPTION:
216# Perform the actual installation including some library fixes. 423# Perform the actual installation including some library fixes.
217qt4-build_src_install() { 424qt4-build_src_install() {
425 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
218 setqtenv 426 setqtenv
427
219 install_directories ${QT4_TARGET_DIRECTORIES} 428 install_directories ${QT4_TARGET_DIRECTORIES}
220 install_qconfigs 429 install_qconfigs
221 fix_library_files 430 fix_library_files
431 fix_includes
432
433 # remove .la files since we are building only shared Qt libraries
434 find "${D}"${QTLIBDIR} -name "*.la" -print0 | xargs -0 rm
222} 435}
223 436
224# @FUNCTION: setqtenv 437# @FUNCTION: setqtenv
225setqtenv() { 438setqtenv() {
226 # Set up installation directories 439 # Set up installation directories
227 QTBASEDIR=/usr/$(get_libdir)/qt4 440 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
228 QTPREFIXDIR=/usr 441 QTPREFIXDIR=${EPREFIX}/usr
229 QTBINDIR=/usr/bin 442 QTBINDIR=${EPREFIX}/usr/bin
230 QTLIBDIR=/usr/$(get_libdir)/qt4 443 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
231 QMAKE_LIBDIR_QT=${QTLIBDIR} 444 QMAKE_LIBDIR_QT=${QTLIBDIR}
232 QTPCDIR=/usr/$(get_libdir)/pkgconfig 445 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
233 QTDATADIR=/usr/share/qt4 446 QTDATADIR=${EPREFIX}/usr/share/qt4
234 QTDOCDIR=/usr/share/doc/qt-${PV} 447 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
235 QTHEADERDIR=/usr/include/qt4 448 QTHEADERDIR=${EPREFIX}/usr/include/qt4
236 QTPLUGINDIR=${QTLIBDIR}/plugins 449 QTPLUGINDIR=${QTLIBDIR}/plugins
450 QTIMPORTDIR=${QTLIBDIR}/imports
237 QTSYSCONFDIR=/etc/qt4 451 QTSYSCONFDIR=${EPREFIX}/etc/qt4
238 QTTRANSDIR=${QTDATADIR}/translations 452 QTTRANSDIR=${QTDATADIR}/translations
239 QTEXAMPLESDIR=${QTDATADIR}/examples 453 QTEXAMPLESDIR=${QTDATADIR}/examples
240 QTDEMOSDIR=${QTDATADIR}/demos 454 QTDEMOSDIR=${QTDATADIR}/demos
241 QT_INSTALL_PREFIX=/usr/$(get_libdir)/qt4 455 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
242 PLATFORM=$(qt_mkspecs_dir) 456 PLATFORM=$(qt_mkspecs_dir)
243 457
244 unset QMAKESPEC 458 unset QMAKESPEC
245} 459}
246 460
249# Sets up some standard configure options, like libdir (if necessary), whether 463# Sets up some standard configure options, like libdir (if necessary), whether
250# debug info is wanted or not. 464# debug info is wanted or not.
251standard_configure_options() { 465standard_configure_options() {
252 local myconf= 466 local myconf=
253 467
254 [[ $(get_libdir) != lib ]] && myconf+=" -L/usr/$(get_libdir)" 468 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
255 469
256 # Disable visibility explicitly if gcc version isn't 4 470 # Disable visibility explicitly if gcc version isn't 4
257 if [[ $(gcc-major-version) -lt 4 ]]; then 471 if [[ $(gcc-major-version) -lt 4 ]]; then
258 myconf+=" -no-reduce-exports" 472 myconf+=" -no-reduce-exports"
259 fi 473 fi
266 else 480 else
267 myconf+=" -release" 481 myconf+=" -release"
268 fi 482 fi
269 myconf+=" -no-separate-debug-info" 483 myconf+=" -no-separate-debug-info"
270 484
485 use aqua && myconf+=" -no-framework"
486
271 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 487 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
272 # $(tc-arch). Therefore we convert it to supported values. 488 # $(tc-arch). Therefore we convert it to supported values.
273 case "$(tc-arch)" in 489 case "$(tc-arch)" in
274 amd64) myconf+=" -arch x86_64" ;; 490 amd64|x64-*) myconf+=" -arch x86_64" ;;
491 ppc-macos) myconf+=" -arch ppc" ;;
275 ppc|ppc64) myconf+=" -arch powerpc" ;; 492 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
493 sparc|sparc-*|sparc64-*) myconf+=" -arch sparc" ;;
494 x86-macos) myconf+=" -arch x86" ;;
276 x86|x86-*) myconf+=" -arch i386" ;; 495 x86|x86-*) myconf+=" -arch i386" ;;
277 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;; 496 alpha|arm|ia64|mips|s390) myconf+=" -arch $(tc-arch)" ;;
278 hppa|sh) myconf+=" -arch generic" ;; 497 hppa|sh) myconf+=" -arch generic" ;;
279 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 498 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
280 esac 499 esac
281 500
282 # 4.6: build qt-core with exceptions or qt-xmlpatterns won't build 501 # exceptions USE flag
283 local exceptions=
284 case "${PV}" in
285 4.6.*)
286 if [[ ${PN} != "qt-core" ]] && [[ ${PN} != "qt-xmlpatterns" ]]; then
287 exceptions="-no-exceptions" 502 local exceptions="-exceptions"
288 fi 503 in_iuse exceptions && exceptions="$(qt_use exceptions)"
289 ;; 504
290 *) 505 # bug 380415
291 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions" 506 version_is_at_least 4.8 && myconf+=" -no-rpath"
292 ;; 507
293 esac 508 # note about -reduce-relocations:
509 # That flag seems to introduce major breakage to applications,
510 # mostly to be seen as a core dump with the message "QPixmap: Must
511 # construct a QApplication before a QPaintDevice" on Solaris
512 # -- Daniel Vergien
513 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
294 514
295 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license 515 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
296 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR} 516 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
297 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR} 517 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
298 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR} 518 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
299 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR} 519 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
300 -demosdir ${QTDEMOSDIR} -silent -fast -opensource 520 -demosdir ${QTDEMOSDIR} -importdir ${QTIMPORTDIR} -silent -fast -opensource
301 ${exceptions} 521 ${exceptions}
302 -reduce-relocations -nomake examples -nomake demos" 522 -nomake examples -nomake demos"
303 523
304 echo "${myconf}" 524 echo "${myconf}"
305} 525}
526
527# @FUNCTION: prepare_directories
528# @USAGE: < directories >
529# @DESCRIPTION:
530# Generates makefiles for the directories set in $QT4_TARGET_DIRECTORIES
531prepare_directories() {
532 for x in "$@"; do
533 pushd "${S}"/${x} >/dev/null
534 einfo "Running qmake in: ${x}"
535 # avoid running over the maximum argument number, bug #299810
536 {
537 echo "${S}"/mkspecs/common/*.conf
538 find "${S}" -name '*.pr[io]'
539 } | xargs sed -i \
540 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
541 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
542 || die
543 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
544 popd >/dev/null
545 done
546}
547
306 548
307# @FUNCTION: build_directories 549# @FUNCTION: build_directories
308# @USAGE: < directories > 550# @USAGE: < directories >
309# @DESCRIPTION: 551# @DESCRIPTION:
310# Compiles the code in $QT4_TARGET_DIRECTORIES 552# Compiles the code in $QT4_TARGET_DIRECTORIES
311build_directories() { 553build_directories() {
312 for x in "$@"; do 554 for x in "$@"; do
313 cd "${S}"/${x} 555 pushd "${S}"/${x} >/dev/null
314 sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:/usr/$(get_libdir)/qt4:g" $(find "${S}" -name '*.pr[io]') "${S}"/mkspecs/common/linux.conf || die 556 emake CC="$(tc-getCC)" \
315 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 557 CXX="$(tc-getCXX)" \
316 emake CC="@echo compiling \$< && $(tc-getCC)" \
317 CXX="@echo compiling \$< && $(tc-getCXX)" \
318 LINK="@echo linking \$@ && $(tc-getCXX)" || die "emake failed" 558 LINK="$(tc-getCXX)" || die "emake failed"
559 popd >/dev/null
319 done 560 done
320} 561}
321 562
322# @FUNCTION: install_directories 563# @FUNCTION: install_directories
323# @USAGE: < directories > 564# @USAGE: < directories >
345# @DESCRIPTION: 586# @DESCRIPTION:
346# List variables that should be defined at the top of QtCore/qconfig.h 587# List variables that should be defined at the top of QtCore/qconfig.h
347: ${QCONFIG_DEFINE:=} 588: ${QCONFIG_DEFINE:=}
348 589
349# @FUNCTION: install_qconfigs 590# @FUNCTION: install_qconfigs
591# @DESCRIPTION:
350# @DESCRIPTION: Install gentoo-specific mkspecs configurations 592# Install gentoo-specific mkspecs configurations
351install_qconfigs() { 593install_qconfigs() {
352 local x 594 local x
353 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 595 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
354 for x in QCONFIG_ADD QCONFIG_REMOVE; do 596 for x in QCONFIG_ADD QCONFIG_REMOVE; do
355 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 597 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
356 done 598 done
357 insinto ${QTDATADIR}/mkspecs/gentoo 599 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
358 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 600 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed"
359 fi 601 fi
360 602
361 if [[ -n ${QCONFIG_DEFINE} ]]; then 603 if [[ -n ${QCONFIG_DEFINE} ]]; then
362 for x in ${QCONFIG_DEFINE}; do 604 for x in ${QCONFIG_DEFINE}; do
363 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 605 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
364 done 606 done
365 insinto ${QTHEADERDIR}/Gentoo 607 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
366 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 608 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
367 fi 609 fi
368} 610}
369 611
370# @FUNCTION: generate_qconfigs 612# @FUNCTION: generate_qconfigs
613# @DESCRIPTION:
371# @DESCRIPTION: Generates gentoo-specific configurations 614# Generates gentoo-specific configurations
372generate_qconfigs() { 615generate_qconfigs() {
373 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 616 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then
374 local x qconfig_add qconfig_remove qconfig_new 617 local x qconfig_add qconfig_remove qconfig_new
375 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 618 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
376 [[ -f ${x} ]] || continue 619 [[ -f ${x} ]] || continue
390 633
391 # generate list of QT_CONFIG entries from the existing list 634 # generate list of QT_CONFIG entries from the existing list
392 # including qconfig_add and excluding qconfig_remove 635 # including qconfig_add and excluding qconfig_remove
393 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 636 for x in $(sed -n 's/^QT_CONFIG +=//p' \
394 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 637 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
395 hasq ${x} ${qconfig_remove} || qconfig_new+=" ${x}" 638 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
396 done 639 done
397 640
398 # replace the existing QT_CONFIG list with qconfig_new 641 # replace the existing QT_CONFIG list with qconfig_new
399 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 642 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
400 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 643 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
424 fi 667 fi
425 fi 668 fi
426} 669}
427 670
428# @FUNCTION: qt4-build_pkg_postrm 671# @FUNCTION: qt4-build_pkg_postrm
672# @DESCRIPTION:
429# @DESCRIPTION: Generate configurations when the package is completely removed 673# Generate configurations when the package is completely removed
430qt4-build_pkg_postrm() { 674qt4-build_pkg_postrm() {
431 generate_qconfigs 675 generate_qconfigs
432} 676}
433 677
434# @FUNCTION: qt4-build_pkg_postinst 678# @FUNCTION: qt4-build_pkg_postinst
679# @DESCRIPTION:
435# @DESCRIPTION: Generate configuration, plus throws a message about possible 680# Generate configuration, plus throws a message about possible
436# breakages and proposed solutions. 681# breakages and proposed solutions.
437qt4-build_pkg_postinst() { 682qt4-build_pkg_postinst() {
438 generate_qconfigs 683 generate_qconfigs
439
440 if [[ "${PN}" == "qt-core" ]]; then
441 echo
442 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
443 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
444 ewarn "should recompile the packages providing these plugins. Also, make sure you"
445 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
446 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
447 ewarn
448 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
449 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
450 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
451 ewarn "configuration."
452 ewarn
453 ewarn "For more information, see http://doc.trolltech.com/${PV%.*}/plugins-howto.html"
454 echo
455 fi
456} 684}
457 685
458# @FUNCTION: skip_qmake_build_patch 686# @FUNCTION: skip_qmake_build
459# @DESCRIPTION: 687# @DESCRIPTION:
460# Don't need to build qmake, as it's already installed from qt-core 688# Don't need to build qmake, as it's already installed from qt-core
461skip_qmake_build_patch() { 689skip_qmake_build() {
462 # Don't need to build qmake, as it's already installed from qt-core 690 # Don't need to build qmake, as it's already installed from qt-core
463 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 691 sed -i -e "s:if true:if false:g" "${S}"/configure || die "sed failed"
464} 692}
465 693
466# @FUNCTION: skip_project_generation_patch 694# @FUNCTION: skip_project_generation
467# @DESCRIPTION: 695# @DESCRIPTION:
468# Exit the script early by throwing in an exit before all of the .pro files are scanned 696# Exit the script early by throwing in an exit before all of the .pro files are scanned
469skip_project_generation_patch() { 697skip_project_generation() {
470 # Exit the script early by throwing in an exit before all of the .pro files are scanned 698 # Exit the script early by throwing in an exit before all of the .pro files are scanned
471 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 699 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \
472 -i "${S}"/configure || die "Sed failed" 700 -i "${S}"/configure || die "sed failed"
473} 701}
474 702
475# @FUNCTION: symlink_binaries_to_buildtree 703# @FUNCTION: symlink_binaries_to_buildtree
476# @DESCRIPTION: 704# @DESCRIPTION:
477# Symlink generated binaries to buildtree so they can be used during compilation 705# Symlink generated binaries to buildtree so they can be used during compilation
478# time 706# time
479symlink_binaries_to_buildtree() { 707symlink_binaries_to_buildtree() {
480 for bin in qmake moc uic rcc; do 708 for bin in qmake moc uic rcc; do
481 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 709 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
482 done 710 done
483} 711}
484 712
485# @FUNCTION: fix_library_files 713# @FUNCTION: fix_library_files
486# @DESCRIPTION: 714# @DESCRIPTION:
487# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 715# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and
488# moves the *.pc-files into the pkgconfig directory 716# moves the *.pc-files into the pkgconfig directory
489fix_library_files() { 717fix_library_files() {
490 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 718 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
491 if [[ -e ${libfile} ]]; then 719 if [[ -e ${libfile} ]]; then
492 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 720 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
493 fi 721 fi
494 done 722 done
495 723
496 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 724 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix:
497 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 725 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
498 if [[ -e ${libfile} ]]; then 726 if [[ -e ${libfile} ]]; then
499 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 727 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed failed"
500 728
501 # Move .pc files into the pkgconfig directory 729 # Move .pc files into the pkgconfig directory
502 dodir ${QTPCDIR} 730 dodir ${QTPCDIR#${EPREFIX}}
503 mv ${libfile} "${D}"/${QTPCDIR}/ \ 731 mv ${libfile} "${D}"/${QTPCDIR}/ \
504 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed." 732 || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
505 fi 733 fi
506 done 734 done
507 735
508 # Don't install an empty directory 736 # Don't install an empty directory
509 rmdir "${D}"/${QTLIBDIR}/pkgconfig 737 rmdir "${D}"/${QTLIBDIR}/pkgconfig
545 *-openbsd*) 773 *-openbsd*)
546 spec=openbsd ;; 774 spec=openbsd ;;
547 *-netbsd*) 775 *-netbsd*)
548 spec=netbsd ;; 776 spec=netbsd ;;
549 *-darwin*) 777 *-darwin*)
778 if use aqua; then
779 # mac with carbon/cocoa
780 spec=macx
781 else
782 # darwin/mac with x11
550 spec=darwin ;; 783 spec=darwin
784 fi
785 ;;
786 *-solaris*)
787 spec=solaris ;;
551 *-linux-*|*-linux) 788 *-linux-*|*-linux)
552 spec=linux ;; 789 spec=linux ;;
553 *) 790 *)
554 die "Unknown CHOST, no platform choosen." 791 die "Unknown CHOST, no platform chosen"
555 esac 792 esac
556 793
557 CXX=$(tc-getCXX) 794 CXX=$(tc-getCXX)
558 if [[ ${CXX} == *g++* ]]; then 795 if [[ ${CXX} == *g++* ]]; then
559 spec+=-g++ 796 spec+=-g++
560 elif [[ ${CXX} == *icpc* ]]; then 797 elif [[ ${CXX} == *icpc* ]]; then
561 spec+=-icc 798 spec+=-icc
562 else 799 else
563 die "Unknown compiler ${CXX}." 800 die "Unknown compiler '${CXX}'"
564 fi 801 fi
565 if [[ -n ${LIBDIR/lib} ]]; then 802 if [[ -n ${LIBDIR/lib} ]]; then
566 spec+=-${LIBDIR/lib} 803 spec+=-${LIBDIR/lib}
567 fi 804 fi
568 805
806 # Add -64 for 64bit profiles
807 if use x64-freebsd ||
808 use amd64-linux ||
809 use x64-macos ||
810 use x64-solaris ||
811 use sparc64-solaris
812 then
813 spec+=-64
814 fi
815
569 echo "${spec}" 816 echo "${spec}"
570} 817}
571 818
819# @FUNCTION: qt_assistant_cleanup
820# @RETURN: nothing
821# @DESCRIPTION:
822# Tries to clean up tools.pro for qt-assistant ebuilds.
823# Meant to be called in src_prepare().
824# Since Qt 4.7.4 this function is a no-op.
825qt_assistant_cleanup() {
826 # apply patching to qt-assistant ebuilds only
827 [[ ${PN} != "qt-assistant" ]] && return
828
829 # no longer needed for 4.7.4 and later
830 version_is_at_least "4.7.4" && return
831
832 # different versions (and branches...) may need different handling,
833 # add a case if you need special handling
834 case "${MY_PV_EXTRA}" in
835 *kde-qt*)
836 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
837 -e "/mac/,/^embedded.*makeqpf$/d" \
838 -i tools/tools.pro || die "patching tools.pro failed"
839 ;;
840 *)
841 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
842 -e "/mac/,/^embedded.*makeqpf$/d" \
843 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
844 -i tools/tools.pro || die "patching tools.pro failed"
845 ;;
846 esac
847}
848
849# @FUNCTION: qt_nolibx11
850# @RETURN: nothing
851# @DESCRIPTION:
852# Ignore X11 tests for packages that don't need X libraries installed
853qt_nolibx11() {
854 einfo "Removing X11 check to allow X-less compilation"
855 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
856 die "x11 check sed failed"
857}
858
572EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst 859EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.55  
changed lines
  Added in v.1.106

  ViewVC Help
Powered by ViewVC 1.1.20